#include "SendRecvThread.h"
#include "MySyncObject.h"		// CMySyncObjectg
#include "RingBuff.h"

// Mx
#define		SEND_BPS	(1000000.0)	// Mx1Mbps

//----------------------------------------------
// function
//    RXgN^
// parameter
//    ConnectionInfoRec *pConInfo	[in]@\ɕKvȏ
// return
//    Ȃ
//----------------------------------------------
CSendRecvThread::CSendRecvThread(ConnectionInfoRec *pConInfo)
{
	m_pConInfo = pConInfo;
	m_fIamZombie = FALSE;
	m_pCRingBuffSend = new CRingBuff(SEND_BUFF_SIZE);
	m_pCRingBuffRecv = new CRingBuff(RECV_BUFF_SIZE);
	m_pCRingBuffForDistributeChat = new CRingBuff(RECV_BUFF_SIZE);

	m_dwPrevSentTime = 0;								// 񑗐M͂
	m_iSendInterval = 0;								// 
}

//----------------------------------------------
// function
//    fXgN^
// parameter
//    Ȃ
// return
//    Ȃ
//----------------------------------------------
CSendRecvThread::~CSendRecvThread()
{
	SAFE_DELETE(m_pCRingBuffSend)
	SAFE_DELETE(m_pCRingBuffRecv)
	SAFE_DELETE(m_pCRingBuffForDistributeChat)
}

//----------------------------------------------
// function
//    @\Lq֐
// parameter
//    Ȃ
// return
//    0: -1:G[
//----------------------------------------------
UINT CSendRecvThread::DoWork()
{
	BOOL		fRet = TRUE;
	char	    szRecvBuffer[RCVBUFSIZE + 1];	// Mobt@
	int			iRecvSize;
	pollfd		fds[1] = { 0 };
	char		*pcData = NULL;				// Mf[^
	int			iSendSize = 0;				// Mf[^TCY
	DWORD		dwNow;						// M`FbNo邽

	fprintf(stderr, "DoWork()\n");
	fds[0].fd = m_pConInfo->fdClient;
	while (!m_fStopFlag)
	{
		// M\Mf[^ƂM\
		iSendSize = m_pCRingBuffSend->GetReadableSize();
		fds[0].events = POLLIN | POLLRDHUP;					// MƑ葤̐ؒfCxgݒ
		// `FbN̂߂Ɍݎ擾
		dwNow = timeGetTime();
		if ((iSendSize > 0) && (CanSendNow(dwNow) == TRUE))
			fds[0].events |= POLLOUT;						// ݉\ǉ

		poll(fds, 1, 10);
		if (fds[0].revents & POLLRDHUP)			// 葤̐ؒf
		{
			fprintf(stderr, "Disconnected pollrdhup\n");
			fRet = FALSE;
			break;
		}
		if (fds[0].revents & POLLERR)			// G[
		{
			m_pConInfo->pCMySyncObject->Lock();
			DispErrorMsg("Err:DoWork");
			m_pConInfo->pCMySyncObject->UnLock();
			fRet = FALSE;
			break;
		}
		if (fds[0].revents & POLLIN)			// Mf[^Cxg
		{
			// MOobt@ɋ󂫂ΎM
			// ŎMȂ΁AreventsŎMs
			iRecvSize = min(m_pCRingBuffRecv->GetWriteableSize(), RCVBUFSIZE);
			if (iRecvSize > 0)
			{
				if ((iRecvSize = recv(m_pConInfo->fdClient, szRecvBuffer, iRecvSize, 0)) <= 0)
				{
					m_pConInfo->pCMySyncObject->Lock();
					if (iRecvSize == 0)
						DispErrorMsg("Disconnected recv");
					else
						DispErrorMsg("Err:recv");
					m_pConInfo->pCMySyncObject->UnLock();
					fRet = FALSE;
					break;
				}
				else
				{
					// MOobt@ɏ 2.2
					m_pCRingBuffRecv->Write((LPBYTE)szRecvBuffer, iRecvSize);
				}
			}
		}
		if (AnalyzeDataRecv() == -1)
		{
			m_pConInfo->pCMySyncObject->Lock();
			DispErrorMsg("Err:Packet format");
			m_pConInfo->pCMySyncObject->UnLock();
			fRet = FALSE;
			break;
		}
		if (fds[0].revents & POLLOUT)		// M\Ȃsend{
		{
			// Mf[^̎擾
			iSendSize = GetSendData(&pcData);
			if (send(m_pConInfo->fdClient, pcData, iSendSize, 0) != iSendSize)
			{
				DispErrorMsg("Err:send");
				fRet = FALSE;
				break;
			}
			SAFE_FREE(pcData)
			// MƎ񑗐M܂ł̎ԂZbg
			m_dwPrevSentTime = dwNow;
			m_iSendInterval = CalcNextSendInterval(iSendSize);
		}
	}
	m_pConInfo->pCMySyncObject->Lock();
	m_fIamZombie = TRUE;
	m_pConInfo->pCMySyncObject->UnLock();
	SAFE_FREE(pcData)
	return((fRet == TRUE) ? 0 : -1);
}

//----------------------------------------------
// function
//		Mf[^̐ݒ
//		MłȂAG[ƂĐؒf̂ǂ
//		͖Ƃ
// parameter
//		char	*pcData	[in]Mf[^
//		int		iSize	[in]f[^
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::SetSendData(char *pcData, int iSize)
{
	BOOL	fRet = FALSE;

	// MOobt@ɋ󂫂ȂƂ͏܂Ȃ
	fRet = m_pCRingBuffSend->Write((LPBYTE)pcData, iSize);
	return(fRet);
}

//----------------------------------------------
// function
//		Mf[^̎擾
// parameter
//		char **ppcData	[in/out]Mf[^
// return
//		f[^
//----------------------------------------------
int CSendRecvThread::GetSendData(char **ppcData)
{
	int		iSize = 0;

	if ((iSize = m_pCRingBuffSend->GetReadableSize()) > 0)
	{
		// MTCYPATH_MTU菬Ă(1024+ʃwb_Ȃv)
		iSize = min(iSize, SENDBUFSIZE);
		*ppcData = (char *)calloc(iSize, sizeof(char));
		iSize = m_pCRingBuffSend->Read((LPBYTE)*ppcData, iSize);
	}
	return(iSize);
}

//----------------------------------------------
// function
//		3.2 `bgbZ[WNCAgɕz邽߂Ɋi[
// parameter
//		char	*pcData	[in]`bgbZ[WpPbg
//		int		iSize	[in]pPbg
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::SetDataForDistributeChat(char *pcData, int iSize)
{
	BOOL	fRet = FALSE;

	// i[pOobt@ɋ󂫂ȂƂ͏܂Ȃ
	fRet = m_pCRingBuffForDistributeChat->Write((LPBYTE)pcData, iSize);
	return(fRet);
}

//----------------------------------------------
// function
//		`bgzpf[^̎擾
//		pPbgPʂŎo
//		͂PpPbg
// parameter
//		char **ppcData	[in/out]`bg]pf[^
// return
//		f[^
//----------------------------------------------
int CSendRecvThread::GetDataForDistributeChat(char **ppcData)
{
	int			iSize = 0, iStoreSize, iPacketSize;
	HeaderRec	Header;

	if ((iStoreSize = m_pCRingBuffForDistributeChat->GetReadableSize()) >= sizeof(HeaderRec))
	{
		// wb_ǂݍ݂
		m_pCRingBuffForDistributeChat->ReadWithoutUpdateHeadPoint((LPBYTE)&Header, sizeof(HeaderRec));
		iPacketSize = ntohs(Header.wDataLen) + sizeof(HeaderRec);
		if (iStoreSize >= iPacketSize)
		{
			*ppcData = (char *)calloc(iPacketSize, sizeof(char));
			iSize = m_pCRingBuffForDistributeChat->Read((LPBYTE)*ppcData, iPacketSize);
		}
	}
	return(iSize);
}


//----------------------------------------------
// function
//    ̃Xbh̓]rԂ
//	  ʃXbhQƂ
// parameter
//    Ȃ
// return
//    0: -1:G[
//----------------------------------------------
BOOL CSendRecvThread::IsZombie()
{
	BOOL	fRet;

	m_pConInfo->pCMySyncObject->Lock();
	fRet = m_fIamZombie;
	m_pConInfo->pCMySyncObject->UnLock();
	return(fRet);
}

//----------------------------------------------
// function
//		Mf[^̉
// parameter
//		Ȃ
// retun
//		0:pPbgĂȂ
//		1:pPbgM̂ŏs
//		-1:G[
//----------------------------------------------
BOOL CSendRecvThread::AnalyzeDataRecv()
{
	int			iRet = 0;
	HeaderRec	Header;
	WORD		wCmd;
	int			iSize = m_pCRingBuffRecv->GetReadableSize();

	if (iSize < sizeof(HeaderRec))			// wb_TCYɖȂƂ͉Ȃ
		goto L_END;

	// wb_؂ǂݍ݂
	m_pCRingBuffRecv->ReadWithoutUpdateHeadPoint((LPBYTE)&Header, sizeof(HeaderRec));
	// wb_̉
	if (memcmp(Header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING)) != 0)
	{
		iRet = -1;							// ʎqႤ̂ŃG[
		goto L_END;
	}
	wCmd = ntohs(Header.wCommand);
	Locate(1, 10, 1);
	fprintf(stderr, "CMD:%d", wCmd);

	switch (wCmd)
	{
		case CMD_MSG_DATA:
			iRet = RecvMessagePacket(&Header);
			break;
		case CMD_SEND_FILE_START_REQ:
		case CMD_SEND_FILE_ING:
		case CMD_SEND_FILE_END_REQ:
			iRet = RecvFileSendPacket(&Header);
			break;
		default:						// mȂR}h
			iRet = -1;
			break;
	}
L_END:
	return(iRet);
}

//----------------------------------------------
// function
//		bZ[WR}h̎M
// parameter
//		HeaderRec *pHeader	[in]ǂ݂wb_
// retun
//		0:pPbgĂȂ
//		1:pPbgM̂ŏs
//		-1:G[
//----------------------------------------------
BOOL CSendRecvThread::RecvMessagePacket(HeaderRec *pHeader)
{
	int			iRet = 0;
	MsgDataRec	*pMsgData;
	int			iMsgSize, iSize;
	char		*pszMsg = NULL;

	iMsgSize = ntohs(pHeader->wDataLen);
	// f[^ȂƂ͉Ȃ
	iSize = m_pCRingBuffRecv->GetReadableSize();
	if (iSize < iMsgSize + sizeof(HeaderRec))
		goto L_END;
	// pPbgŜMĂ̂œǂݍ݂{
	pMsgData = (MsgDataRec *)calloc(iMsgSize + sizeof(HeaderRec), sizeof(BYTE));
	m_pCRingBuffRecv->Read((LPBYTE)pMsgData, iMsgSize + sizeof(HeaderRec));
	// NULL^[~l[gǉĊm
	pszMsg = (char *)calloc(iMsgSize + 1, sizeof(char));
	memcpy(pszMsg, pMsgData->bMsgData, iMsgSize);

	// `bgM̂߂ɃbZ[Wf[^pPbgăZbg
	SendMessagePacket(pszMsg, iMsgSize);

	m_pConInfo->pCMySyncObject->Lock();
	fprintf(stderr, "Msg:recv %s\n", pszMsg);
	m_pConInfo->pCMySyncObject->UnLock();

	SAFE_FREE(pMsgData)
	SAFE_FREE(pszMsg)
	iRet = 1;
L_END:
	return(iRet);
}

int CSendRecvThread::RecvFileSendPacket(HeaderRec *pHeader)
{
	int			iRet = 0;
	int			iDataSize, iSize;
	LPBYTE		pbPacket = NULL;

	iDataSize = ntohs(pHeader->wDataLen);

	iSize = m_pCRingBuffRecv->GetReadableSize();
	if (iSize < iDataSize + sizeof(HeaderRec))
		goto L_END;
	pbPacket = (LPBYTE)calloc(iDataSize + sizeof(HeaderRec), sizeof(BYTE));
	m_pCRingBuffRecv->Read((LPBYTE)pbPacket, iDataSize + sizeof(HeaderRec));

	{
		WORD wCmd = ntohs(pHeader->wCommand);
		switch (wCmd)
		{
			case CMD_SEND_FILE_START_REQ:			// MJnvM
			{
				SendFileStartReqRec *pD = (SendFileStartReqRec *)pbPacket;
				Locate(1, 11, 2);
				fprintf(stderr, "Start %s %s(%u)", pD->FileInfo.szFileName, pD->FileInfo.szFileSize, timeGetTime());
				break;
			}
			case CMD_SEND_FILE_ING:					// t@CM
			{
				SendFileIngRec *pD = (SendFileIngRec *)pbPacket;
				Locate(1, 12, 1);
				fprintf(stderr, "Ing %s %s", pD->Stat.szOffset, pD->Stat.szSize);
				break;
			}
			case CMD_SEND_FILE_END_REQ:				// MvM
				SendFileEndReqRec *pD = (SendFileIngRec *)pbPacket;
				Locate(1, 13, 1);
				fprintf(stderr, "End %s %s(%u)", pD->Stat.szOffset, pD->Stat.szSize, timeGetTime());
				break;
		}
	}


	SAFE_FREE(pbPacket);
	iRet = 1;

L_END:
	return(iRet);
}



//----------------------------------------------
// function
//		bZ[WpPbg̑M
//		`bgbZ[WNCAgɓ]邽߂̃GA
//		i[
// parameter
//		char	*pcData		[in]UTF-8f[^(NULL^[~l[gȂ)
//		int		iSize		[in]f[^TCY
// retun
//		Ȃ
//----------------------------------------------
BOOL CSendRecvThread::SendMessagePacket(char *pcData, int iSize)
{
	MsgDataRec	*pMsgData = NULL;
	int			iPacketSize = sizeof(HeaderRec) + iSize;		// pPbgTCY
	BOOL		fRet = FALSE;

	pMsgData = (MsgDataRec *)calloc(iPacketSize, sizeof(BYTE));	// pPbgŜ̃GAm

	memcpy(pMsgData->header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING));
	pMsgData->header.wCommand = htons(CMD_MSG_DATA);
	pMsgData->header.wDataLen = htons(iSize);

	memcpy(pMsgData->bMsgData, pcData, iSize);
	// `bgM̂߂ɃbZ[WpPbgf[^Zbg
	fRet = SetDataForDistributeChat((char *)pMsgData, iPacketSize);

	SAFE_FREE(pMsgData)
	return(fRet);
}

//----------------------------------------------
// function
//		̑M܂ł̊Ԋu(msec)߂
// parameter
//		Ȃ
// return
//		msec
//----------------------------------------------
int CSendRecvThread::CalcNextSendInterval(int iSentSize)
{
	int		iInterval = 0;
	double	dbBytePerSec = SEND_BPS / 8.0;
	double	dbCountPerSec;

	if (iSentSize == 0)
		goto L_END;
	dbCountPerSec = dbBytePerSec / (double)iSentSize;
	iInterval = int(1000.0 / dbCountPerSec);

L_END:
	return(iInterval);
}


//----------------------------------------------
// function
//		M\
// parameter
//		DWORD dwNow		[in]ݎ
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::CanSendNow(DWORD dwNow)
{
	BOOL	fRet = FALSE;

	if (GetdwInterval(dwNow, m_dwPrevSentTime) >= (DWORD)m_iSendInterval)
		fRet = TRUE;

	return(fRet);
}

